'* Demo code:
CLS
PRINT @(0,50);
'usage: LineEdit2$(EdString$,Pattern$,CursorPos,DelEnabled)
'DelEnabled = 1 or 0 for disabled
a$= LineEdit2$("The Backshed","0123456789ABCDEFabcdef",3,0)' eg for hex numbers
'a$= LineEdit2$("The Backshed","",1,1)'general use
PRINT
PRINT a$
END

'*************************************************
'*
'* LineEdit2$ V.93
'*
'* MMBasic 4.5/Maximite/CMM2 Basic 5.05.05
'*
'* by twofingers 09-2014/10-2020 at TBS
'* line editor for small strings (e.g. file names)
'*------------------------------------------------
'* Limit:
'* The string must not exceed the width of screen
'*
'* Supported keys:
'* left arrow, right arrow
'* Enter
'* ESC
'* Home
'* End
'* Del
'* Backspace
'* all ASCII chars (char 32-126)
'*
'* Usage: LineEdit2$(EdString$,Pattern$,CursorPos,DelEnabled)
'* DelEnabled = 1 or 0 for disabled
'*
'*------------------------------------------------
'* possible improvments:
'* 1. insertmode
'* 2. a fixed minimum string size
'*************************************************
' This code may be freely distributed and
' changed. Provided AS IS without any warranty.
' Use it at your own risk.
'*********************************************************** *
FUNCTION LineEdit2$(txt$,Pattern$,Cursorp,DelEnabled) AS STRING
  LOCAL INTEGER hpos, vpos, p, ep, keyvalue, enterPressed
  LOCAL STRING  ltext$, mtext$, rtext$
  LOCAL INTEGER TRUE=1, FALSE=0, waitStates=100

  hpos=MM.INFO(HPos)
  vpos=MM.INFO(VPos) ' save print position

  enterPressed=FALSE ' Flag to EXIT the loop
  p=LEN(txt$)        ' cursor pointer
  LineEdit$=txt$     ' backup text$ for Esc
  ep=Len(txt$)       ' end pointer
  p=cursorp:If p<1 or p>ep Then p=1 ' cursor pointer

  IF txt$<>"" THEN
    DO

      ltext$=Mid$(txt$,1,p-1)
      mtext$=Mid$(txt$,p,1)
      rtext$=Mid$(txt$,p+1,ep-p)
  
      Print @(hpos,vpos)ltext$;
      color rgb(black),rgb(white)
      Print mtext$;
      color rgb(white),rgb(black)
      Print rtext$;

'    waitStates=0  :DO:keyvalue=ASC(inkey$):PAUSE 0:LOOP WHILE keyvalue=0' for terminal mode
      waitStates=100:DO:keyvalue=keydown(1):PAUSE 20:LOOP WHILE keyvalue=0' USB Keyboard only

      SELECT CASE keyvalue
        CASE 10 'Enter
          enterPressed=TRUE 
        CASE 27 'ESC, leave LineEdit$ untouched
          PRINT @(hpos,vpos) LineEdit$;
          EXIT FUNCTION 
        CASE 130 'left arrow
          IF p>1  THEN p=p-1 
        CASE 131 'right arrow
          IF p<ep THEN p=p+1 
        CASE 134 'Home
          p=1 
        CASE 135 'End
          p=ep 
        CASE 33-DelEnabled TO 126 'all ASCII chars
          if pattern$="" or inStr(pattern$,chr$(keyvalue)) then
            IF p<ep THEN
              p=p+1
              ltext$=ltext$+CHR$(keyvalue)
              mtext$=MID$(txt$,p,1)
              rtext$=MID$(txt$,p+1)
            ELSE
              ltext$=LEFT$(txt$,p-1)
              mtext$=CHR$(keyvalue)
              rtext$=""
            ENDIF
          ENDIF
        CASE 8 'Backspace
          IF DelEnabled THEN 
            IF p>1 THEN 
              p=p-1
              ltext$=MID$(txt$,1,p-1)
              mtext$=" " 'blank replacement
              rtext$=MID$(txt$,p+1)
            ENDIF
          ENDIF
        CASE 127  'Del
          IF DelEnabled THEN 
            ltext$=MID$(txt$,1,p-1)
            mtext$=" " 'blank replacement
            rtext$=MID$(txt$,p+1)
          ENDIF
      END SELECT

      txt$=ltext$+mtext$+rtext$

      PAUSE 50+waitStates ' some wait states to slow down key input
    LOOP UNTIL enterPressed
  endif ' txt$<>""
  LineEdit2$=txt$
  PRINT @(hpos,vpos)LineEdit2$;
END FUNCTION
'*****************************************************
                                              